#include "standard.h"
#include "definitions.h"
#include "typedefs.h"

   ofstream esurf("esurf", ios::out);
   ofstream ndist("ndist", ios::out);
   ofstream adist("adist", ios::out);
   ofstream convd("convd", ios::out);
   ofstream energy("energy", ios::out);

/*==========================================================================*/
void output(System *X, int K, int nstep, int type)
/*-------------------------------------------------------------------------*/
{ /*begin routine */
/*-------------------------------------------------------------------------*/

    int i,k,ii,jj;
    int hdim;
    int system;
    double dmin, resol;
    double xi;

    hdim = X[0].hdim;
    dmin = X[0].dmin;
    resol = X[0].resol;
    system = X[0].pot_type; 

    if (type == 1) {//distribution//
        for (i=1;i<=hdim;i++) {
             xi = dmin + (i-0.5)*resol;
             ndist << xi;
             adist << xi;
             esurf  << xi <<'\t'<< vpot(xi,system) << endl;
             for (k=0;k<=K;k++) { 
                  ndist <<'\t'<< X[k].dist[i];
                  adist <<'\t'<< X[k].dista[i];
             }
             ndist << endl;
             adist << endl;
        }
    }//endif distribution//
    if (type == 2) {//convergence, energy//
             convd << nstep;
             for (k=0;k<=K;k++) { 
                  convd <<'\t'<< X[k].f_d;
             }
             convd << endl;
             energy << nstep;
             for (k=0;k<=K;k++) { 
                  energy <<'\t'<< vpot(X[k].x,system);
             }
             energy << endl;
    }//endif convergence//
/*-------------------------------------------------------------------------*/
} /*end routine */
/*=========================================================================*/

